# Laravel入门教程——一个简单cms的实现(01)

>    作者: douyasi  
>    网站：http://douyasi.com/category/startlaravel/
>    备注：本教程是在当前最新Laravel稳定版v4.2.X下实现的，其它相异版本如果有问题请自行排除。  
>    本文为作者原创记录，转载请保留署名与来源。

## 准备性工作

### 说明

这里准备性工作是指“实现这个cms项目之前必须完成的事务”，比如：
**需求的明确**，**前端页面的设计与实现**，**框架初始化环境的搭建**，**数据库模型的设计**等。

这里我就不多列举出来啊，这些准备性的工作有时也会耗费不少精力，尤其是在我自己一个人独立完成的情况下。

### 系统目标与需求
下面简单的说下，这个简单cms最主要实现的目标和需求吧：



```
    1.前台文章展示：
    文章有分类、标签；  
    文章类型分单页、普通文章，后期会扩展一些其它模型，比如图片、软件等。      
    2.后台文章管理：
    实现增删改查文章，文章可以使用Markdown来编辑      
    3.用户管理：
    实现对后台用户的管理，包含登录模块   
    4.系统设置管理：
    实现对系统一些常变量的设置、配置等 
```

使用的前后台页面都是本人自行设计与代码实现的，本cms的设计与实现一定程度上地受到 [typecho](http://typecho.org/) 的启发，感想 [typecho](http://typecho.org/)。 

### 安装Laravel框架

如果对安装 `Laravel` 框架还有疑惑或困难的，建议多看下 `Laravel` 帮助手册。

### 初始配置Laravel框架

参照官方帮助，我们需要修改一些配置文件。

>    修改 `/app/config/app.php` 文件，开启debug：

```php
'debug' => true,
```

>    使用 `php artisan` 来生成32应用程序的key，在命令行终端里输入以下命令：

```bash
    php artisan key:generate
```

>    会在 `/app/config/app.php` 文件里生成类似于下面的32位字符串配置项： 

```
	'key' => 'RDFRcyFo3CulrDUMHmUDDm7CnVlQzIXb',
```

>    根据自己数据库实际，修改 `/app/config/database.php` 里面数据库相关配置项：

```php
		'mysql' => array(
			'driver'    => 'mysql',
			'host'      => 'localhost',
			'database'  => 'laravel_cmf',
			'username'  => 'root',
			'password'  => 'root',
			'charset'   => 'utf8',
			'collation' => 'utf8_unicode_ci',
			'prefix'    => 'yascms_',
		),
```

准备性工作已经完成了，下一节，我们将开始使用Artisan和Migrations工具进行建立数据库操作。